(*--------------------------------NetWorks.pas-----------------------------
 V1.0.1 - 11.08.2002 - initial release / current release
*------------------------------------------------------------------------*)

unit NetWorks;

interface

uses Classes;

type
{   TDWIPAdress = packed record
      IP1,
      IP2,
      IP3,
      IP4: Byte;
   end;}

   TDWHostConnectInfo = packed record
      Host: String;
      Port: Word;
   end;

   TDWInternetConnectedState = (dwicsConfigured,
                                dwicsLAN,
                                dwicsModem,
                                dwicsOffline,
                                dwicsProxy,
                                dwicsRASInstalled);
   TDWInternetConnectedStates = set of TDWInternetConnectedState;

   TDWInternetProxySetting = packed record
      HTTP,
      HTTPS,
      FTP,
      Gopher,
      Socks:   TDWHostConnectInfo;
   end;

(*V1.0.1*)
function ChangeNetUserPassword(const Username, OldPassword, NewPassword: String): Boolean;
//function GetDomainName: AnsiString;
function GetHostNameByIP(const IPAdress: String): String;
function GetInetSideIP: String;
function GetInternetConnectionState(var InternetConnectedStates: TDWInternetConnectedStates): Boolean;
function GetInternetProxySetting(var InternetProxySetting: TDWInternetProxySetting): Boolean;
function GetIPAdress: String;
function GetIPByHostName(const HostName: String): String;
function GetMACAdress: String;
function GetProxyIgnoredAdresses(var Adresses: TStringList): Boolean;

implementation

uses Windows, SysUtils, NB30, WinInet, WinSock, Registry, StringWorks,
     OSWorks;

function GetInetSideIP: String;
var WS:WSAData;s:TSocket;adr:sockaddr_in;
    buf:string;i,pos_:integer;
begin
   WSAStartUp($0101,WS);
   adr.sin_family:=PF_INET;
   adr.sin_port:=htons(25);
   adr.sin_addr.S_addr:=inet_addr('217.72.192.157');
   s:=Socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
   connect(s,adr,SizeOf(adr));
   buf:='HELO HELO'#13#10;
   Sleep(110);
   Send(s,buf[1],Length(buf),0);
   Sleep(110);
   SetLength(buf,65536);
   for i:=1to length(buf)do
      buf[i]:=#0;
   pos_:=1;
   ioctlsocket(s,FIONBIO,pos_);
   pos_:=0;
   repeat
      i:=recv(s,buf[1+pos_],Length(buf)-pos_,0);
      pos_:=pos_+i;
   until i<=0;
   CloseSocket(s);
   buf:=Copy(buf,Pos('[',buf)+1,Length(buf));
   buf:=Copy(buf,1,Pos(']',buf)-1);
   result:= buf;
   WSACleanUp;
end;

function _NetUserChangePassword(Domain: PWideChar; UserName: PWideChar; OldPassword: PWideChar;
            NewPassword: PWideChar): Longint; stdcall; external 'netapi32.dll'
            Name 'NetUserChangePassword';

function ChangeNetUserPassword(const Username, OldPassword, NewPassword: String): Boolean;
const NERR_Success = $0;
begin
   result:= (_NetUserChangePassword(
                PWideChar(WideString('\\COMPUTER')),
                PWideChar(WideString('username')),
                PWideChar(WideString('oldpass')),
                PWideChar(WideString('newpass'))) = NERR_Success);
end;

{function GetDomainName: AnsiString;
type
  //Win9X ANSI prototypes from RADMIN32.DLL and RLOCAL32.DLL
  // look at http://www.mvps.org/win32/network/nt95.html for download...
  TWin95_NetWkstaUserGetInfo = function(Reserved: PChar; Level: Integer; var
    BufPtr: Pointer): Integer;
  stdcall;
  TWin95_NetApiBufferFree = function(BufPtr: Pointer): Integer;
  stdcall;
  TWin95_NetGetDCName = function(ServerName: PChar; domain: PChar; var
    BufPtr: Pointer): Integer;
  stdcall;
  TWin95_NetUserEnum = function(ServerName: PChar; Level, Filter: DWORD; var
    BufPtr: Pointer; PrefMax: DWORD; var read, Total, Resume: DWORD): Integer;
  stdcall;
  TWin95_NetLocalGroupEnum = function(ServerName: PChar; Level: DWORD; var
    BufPtr: Pointer; PrefMax: DWORD; var read, Total, Resume: DWORD): Integer;
  stdcall;
  TWin95_NetRemoteTOD = function(ServerName: PChar; var
    pTOD: Pointer): Integer;
  stdcall;
  TWin95_NetUserGetInfo = function(ServerName, UserName: PChar; Level: DWORD;
  var BfrPtr: Pointer): Integer;
  stdcall;
  //WinNT UNICODE equivalents from NETAPI32.DLL
  TWinNT_NetWkstaGetInfo = function(ServerName: PWideChar; level: Integer;
  var BufPtr: Pointer): Integer;
  stdcall;
  TWinNT_NetApiBufferFree = function(BufPtr: Pointer): Integer;
  stdcall;
  TWinNT_NetGetAnyDCName = function(ServerName: PWideChar;
    domain: PWideChar; var BufPtr: PWideChar): Integer;
  stdcall;
  TWinNT_NetGetDCName = function(ServerName: PWideChar; domain: PWideChar;
  var BufPtr: PWideChar): Integer;
  stdcall;
  TWinNT_NetUserEnum = function(ServerName: PWideChar; Level, Filter: DWORD;
  var BufPtr: Pointer; PrefMax: DWORD; var read, Total, Resume: DWORD): Integer;
  stdcall;
  TWinNT_NetLocalGroupEnum = function(ServerName: PWideChar; Level: DWORD;
  var BufPtr: Pointer; PrefMax: DWORD; var read, Total, Resume: DWORD): Integer;
  stdcall;
  TWinNT_NetRemoteTOD = function(ServerName: PWideChar; var
    pTOD: Pointer): Integer;
  stdcall;
  TWinNT_NetUserGetInfo = function(ServerName, UserName: PWideChar;
    Level: DWORD; var BfrPtr: Pointer): Integer;
  stdcall;
type
  WKSTA_INFO_100 = record
    wki100_platform_id: Integer;
    wki100_computername: PWideChar;
    wki100_langroup: PWideChar;
    wki100_ver_major: Integer;
    wki100_ver_minor: Integer;
  end;
  WKSTA_USER_INFO_1 = record
    wkui1_username: PChar;
    wkui1_logon_domain: PChar;
    wkui1_logon_server: PChar;
    wkui1_oth_domains: PChar;
  end;
  USER_INFO_1000 = record
    usri10_name: PWideChar;
    usri10_comment: PWideChar;
    usri10_usr_comment: PWideChar;
    usri10_full_name: PWideChar
  end;
  USER_INFO_10 = record
    usri10_name: PChar;
    usri10_comment: PChar;
    usri10_usr_comment: PChar;
    usri10_full_name: PChar
  end;
var
  Win95_NetApiBufferFree: TWin95_NetApiBufferFree;
  Win95_NetWkstaUserGetInfo: TWin95_NetWkstaUserGetInfo;
  Win95_NetGetDCName: TWin95_NetGetDCName;
  Win95_NetUserEnum: TWin95_NetUserEnum;
  Win95_NetLocalGroupEnum: TWin95_NetLocalGroupEnum;
  Win95_NetRemoteTOD: TWin95_NetRemoteTOD;
  Win95_NetUserGetInfo: TWin95_NetUserGetInfo;
  WinNT_NetApiBufferFree: TWinNT_NetApiBufferFree;
  WinNT_NetWkstaGetInfo: TWinNT_NetWkstaGetInfo;
  WinNT_NetGetDCName: TWinNT_NetGetDCName;
  WinNT_NetGetAnyDCName: TWinNT_NetGetAnyDCName;
  WinNT_NetUserEnum: TWinNT_NetUserEnum;
  WinNT_NetLocalGroupEnum: TWinNT_NetLocalGroupEnum;
  WinNT_NetRemoteTOD: TWinNT_NetRemoteTOD;
  WinNT_NetUserGetInfo: TWinNT_NetUserGetInfo;
  WSNT: ^WKSTA_INFO_100;
  WSNTu: ^USER_INFO_1000;
  WS95: ^WKSTA_USER_INFO_1;
  EC: DWORD;
  hNETAPI: THandle;
begin
  try
    Result := '';
    if IsNTMachine then
    begin
      hNETAPI := LoadLibrary('NETAPI32.DLL');
      if hNETAPI <> 0 then
      begin @WinNT_NetWkstaGetInfo := GetProcAddress(hNETAPI, 'NetWkstaGetInfo');
          @WinNT_NetGetDCName := GetProcAddress(hNETAPI, 'NetGetDCName');
          @WinNT_NetGetAnyDCName := GetProcAddress(hNETAPI, 'NetGetAnyDCName');
          @WinNT_NetApiBufferFree := GetProcAddress(hNETAPI, 'NetApiBufferFree');
          @WinNT_NetUserEnum := GetProcAddress(hNETAPI, 'NetUserEnum');
          @WinNT_NetLocalGroupEnum := GetProcAddress(hNETAPI, 'NetLocalGroupEnum');
          @WinNT_NetRemoteTOD := GetProcAddress(hNETAPI, 'NetRemoteTOD');
          @WinNT_NetUserGetInfo := GetProcAddress(hNETAPI, 'NetUserGetInfo');
        EC := WinNT_NetWkstaGetInfo(nil, 100, Pointer(WSNT));
        if EC = 0 then
        begin
          Result := WideCharToString(WSNT^.wki100_langroup);
          WinNT_NetApiBufferFree(Pointer(WSNT));
        end;
      end;
    end
    else
    begin
      hNETAPI := LoadLibrary('RADMIN32.DLL');
      if hNETAPI <> 0 then
      begin @Win95_NetGetDCName := GetProcAddress(hNETAPI, 'NetGetDCNameA');
          @Win95_NetApiBufferFree := GetProcAddress(hNETAPI, 'NetApiBufferFree');
          @Win95_NetWkstaUserGetInfo := GetProcAddress(hNETAPI, 'NetWkstaUserGetInfoA');
          @Win95_NetUserEnum := GetProcAddress(hNETAPI, 'NetUserEnumA');
          @Win95_NetLocalGroupEnum := GetProcAddress(hNETAPI, 'NetGroupEnumA');
          @Win95_NetRemoteTOD := GetProcAddress(hNETAPI, 'NetRemoteTODA');
          @Win95_NetUserGetInfo := GetProcAddress(hNETAPI, 'NetUserGetInfoA');
        EC := Win95_NetWkstaUserGetInfo(nil, 1, Pointer(WS95));
        if EC = 0 then
        begin
          Result := WS95^.wkui1_logon_domain;
          Win95_NetApiBufferFree(Pointer(WS95));
        end;
      end;
    end;
  finally
    if hNETAPI <> 0 then
      FreeLibrary(hNETAPI);
  end;
end;}

function GetIPByHostName(const HostName: String): String;
type
  TaPInAddr = array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  i: Integer;
  GInitData: TWSAData;
begin
  WSAStartup($101, GInitData);
  Result := '';
  phe := GetHostByName(PChar(HostName));
  if phe = nil then Exit;
  pPtr := PaPInAddr(phe^.h_addr_list);
  i := 0;
  while pPtr^[i] <> nil do
  begin
    Result := inet_ntoa(pptr^[i]^);
    Inc(i);
  end;
  WSACleanup;
end;

function GetInternetProxySetting(var InternetProxySetting: TDWInternetProxySetting): Boolean;
var
   proxyString: String;

{   function StrToIP(const Str: String): TDWIPAdress;
   begin
      ZeroMemory(@result, SizeOf(TDWIPAdress));
      if Str<>'' then begin
         with TStringList.Create do begin
            Assign(StrToList(Str, '.'));
            with result do begin
               IP1:= StrToIntDef(Strings[0], 0);
               IP2:= StrToIntDef(Strings[1], 0);
               IP3:= StrToIntDef(Strings[2], 0);
               IP4:= StrToIntDef(Strings[3], 0);
            end;
            Free;
         end;
      end;
   end; }

   function HostStrToHostConnectInfo(const Str: String): TDWHostConnectInfo;
   begin
      ZeroMemory(@result, SizeOf(TDWHostConnectInfo));
      with TStringList.Create do begin
         Assign(StrToList(Str, ':'));
         with result do begin
            Host:= Strings[0];
            Port:= StrToIntDef(Strings[1], 0);
         end;
         Free;
      end;
   end;

   function ExtractOverSet(const Str: String; var Typ: String): String;
   begin
      with TStringList.Create do begin
         Assign(StrToList(Str, '='));
         Typ:= Strings[0];
         result:= Strings[1];
         Free;
      end;
   end;

{   function ValidateHostID(const Str: String): Boolean;
   begin
      result:= Pos('.', Str)=0;
   end;}

   function ProxyStrToProxySetting(const Str: String): TDWInternetProxySetting;
   var
      I: Integer;
      Typ, Host: String;
   begin
      with TStringList.Create do begin
         if Pos('=', Str)>0 then begin
            Assign(StrToList(Str, ';'));
            for I:= 0 to Count - 1 do begin
               Host:= ExtractOverSet(Strings[I], Typ);
               if Typ = 'ftp' then result.FTP:= HostStrToHostConnectInfo(Host);
               if Typ = 'gopher' then result.Gopher:= HostStrToHostConnectInfo(Host);
               if Typ = 'http' then result.HTTP:= HostStrToHostConnectInfo(Host);
               if Typ = 'https' then result.HTTPS:= HostStrToHostConnectInfo(Host);
               if Typ = 'socks' then result.Socks:= HostStrToHostConnectInfo(Host);
            end;
         end else begin
            with result do begin
               HTTP:= HostStrToHostConnectInfo(Str);
               HTTPS:= HTTP;
               FTP:= HTTP;
               Gopher:= HTTP;
               Socks:= HTTP;
            end;
         end;
         Free;
      end;
   end;

begin
   result:= FALSE;
   with TRegistry.Create(KEY_READ) do begin
      RootKey:= HKEY_CURRENT_USER;
      if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Internet Settings\', FALSE) then begin
         result:= ReadBool('ProxyEnable');
         if result then begin
            proxyString:= ReadString('ProxyServer');
            InternetProxySetting:= ProxyStrToProxySetting(proxyString);
         end;
      end;
      Free;
   end;
end;

function GetHostNameByIP(const IPAdress: String): String;
var
  SockAddrIn: TSockAddrIn;
  HostEnt: PHostEnt;
  WSAData: TWSAData;
begin
  WSAStartup($101, WSAData);
  SockAddrIn.sin_addr.s_addr := inet_addr(PChar(IPAdress));
  HostEnt := gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
  if HostEnt <> nil then
    Result := StrPas(Hostent^.h_name)
  else
    Result := '';
end;

function GetIPAdress: String;
type
  TaPInAddr = array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: array[0..63] of Char;
  I: Integer;
  GInitData: TWSAData;
begin
  WSAStartup($101, GInitData);
  Result := '';
  GetHostName(Buffer, SizeOf(Buffer));
  phe := GetHostByName(buffer);
  if phe = nil then Exit;
  pPtr := PaPInAddr(phe^.h_addr_list);
  I    := 0;
  while pPtr^[I] <> nil do
  begin
    Result := inet_ntoa(pptr^[I]^);
    Inc(I);
  end;
  WSACleanup;
end;

function GetInternetConnectionState(var InternetConnectedStates: TDWInternetConnectedStates): Boolean;
const
   INTERNET_CONNECTION_MODEM =          $01;
   INTERNET_CONNECTION_LAN =            $02;
   INTERNET_CONNECTION_PROXY =          $04;
   (*following implemented in W2k*)
   INTERNET_RAS_INSTALLED =             $10;
   INTERNET_CONNECTION_OFFLINE =        $20;
   INTERNET_CONNECTION_CONFIGURED =     $40;
var
   Flags: DWord;
begin
   Flags:= 0;
   result:= InternetGetConnectedState(@Flags, 0);
   if ((Flags and INTERNET_CONNECTION_MODEM) =      INTERNET_CONNECTION_MODEM)
      then Include(InternetConnectedStates, dwicsModem);
   if ((Flags and INTERNET_CONNECTION_LAN) =        INTERNET_CONNECTION_LAN)
      then Include(InternetConnectedStates, dwicsLAN);
   if ((Flags and INTERNET_CONNECTION_PROXY) =      INTERNET_CONNECTION_PROXY)
      then Include(InternetConnectedStates, dwicsProxy);
   if ((Flags and INTERNET_RAS_INSTALLED) =         INTERNET_RAS_INSTALLED)
      then Include(InternetConnectedStates, dwicsRASInstalled);
   if ((Flags and INTERNET_CONNECTION_OFFLINE) =    INTERNET_CONNECTION_OFFLINE)
      then Include(InternetConnectedStates, dwicsOffline);
   if ((Flags and INTERNET_CONNECTION_CONFIGURED) = INTERNET_CONNECTION_CONFIGURED)
      then Include(InternetConnectedStates, dwicsConfigured);
end;

function GetMACAdress: String;
var
  NCB: PNCB;
  Adapter: PAdapterStatus;
  RetCode: char;
  I: integer;
  Lenum: PlanaEnum;
  _SystemID: string;
begin
  Result    := '';
  _SystemID := '';
  Getmem(NCB, SizeOf(TNCB));
  Fillchar(NCB^, SizeOf(TNCB), 0);
  Getmem(Lenum, SizeOf(TLanaEnum));
  Fillchar(Lenum^, SizeOf(TLanaEnum), 0);
  Getmem(Adapter, SizeOf(TAdapterStatus));
  Fillchar(Adapter^, SizeOf(TAdapterStatus), 0);
  Lenum.Length    := chr(0);
  NCB.ncb_command := chr(NCBENUM);
  NCB.ncb_buffer  := Pointer(Lenum);
  NCB.ncb_length  := SizeOf(Lenum);
//  RetCode         := Netbios(NCB);
  i := 0;
  repeat
    Fillchar(NCB^, SizeOf(TNCB), 0);
    Ncb.ncb_command  := chr(NCBRESET);
    Ncb.ncb_lana_num := lenum.lana[I];
//    RetCode          := Netbios(Ncb);
    Fillchar(NCB^, SizeOf(TNCB), 0);
    Ncb.ncb_command  := chr(NCBASTAT);
    Ncb.ncb_lana_num := lenum.lana[I];
    // Must be 16
    Ncb.ncb_callname := '*               ';
    Ncb.ncb_buffer := Pointer(Adapter);
    Ncb.ncb_length := SizeOf(TAdapterStatus);
    RetCode        := Netbios(Ncb);
    //---- calc _systemId from mac-address[2-5] XOR mac-address[1]...
    if (RetCode = chr(0)) or (RetCode = chr(6)) then
    begin
      _SystemId := IntToHex(Ord(Adapter.adapter_address[0]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[1]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[2]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[3]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[4]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[5]), 2);
    end;
    Inc(i);
  until (I >= Ord(Lenum.Length)) or (_SystemID <> '00-00-00-00-00-00');
  FreeMem(NCB);
  FreeMem(Adapter);
  FreeMem(Lenum);
  GetMacAdress := _SystemID;
end;

function GetProxyIgnoredAdresses(var Adresses: TStringList): Boolean;
var I: Integer;
begin
   with Adresses do begin
      with TRegistry.Create(KEY_READ) do begin
         RootKey:= HKEY_CURRENT_USER;
         if OpenKey('\Software\Microsoft\Windows\CurrentVersion\Internet Settings\', FALSE) then begin
            Assign(StrToList(ReadString('ProxyOverride'), ';'));
         end;
         Free;
      end;
      for I:= 0 to Count - 1 do begin
         if Strings[I] = '<local>' then Strings[I]:= '127.0.0.1';
      end;
      result:= (Count>0);
   end;
end;

end.
